import { createResponderCheckRateLimit } from "dr-js/module/node/server/Responder/RateLimit";
import { getParamFromRequest } from "../../function";
const createResponderCheckAuth = ({authPack: {authKey, checkAuth}, responderNext, responderDeny}) => createResponderCheckRateLimit({
  checkFunc: async store => {
    const authToken = await checkAuth(getParamFromRequest(store, authKey));
    store.setState({
      authToken
    });
    return !0;
  },
  responderNext,
  responderDeny
});
const createResponderGrantAuthHeader = ({authPack: {authKey, generateAuthHeader}, responder}) => async (store, requestTag) => {
  store.response.setHeader(authKey, await generateAuthHeader(requestTag));
  return responder(store);
};
export { createResponderCheckAuth, createResponderGrantAuthHeader };