import { binary } from "dr-js/module/common/format";
import { parseBufferPacket, packBufferPacket } from "dr-js/module/node/data/BufferPacket";
import { responderSendBufferCompress } from "dr-js/module/node/server/Responder/Send";
import { fetchLikeRequest } from "dr-js/module/node/net";
const responderServerFetch = async store => {
  const [headerString, requestBodyBuffer] = parseBufferPacket(await store.requestBuffer());
  const {url, option = {}} = JSON.parse(headerString);
  const {status, headers, buffer} = await fetchLikeRequest(url, {
    ...option,
    body: requestBodyBuffer
  });
  const responseBodyBuffer = await buffer();
  return responderSendBufferCompress(store, {
    buffer: packBufferPacket(JSON.stringify({
      status,
      headers
    }), responseBodyBuffer)
  });
};
export { responderServerFetch };