import { BASIC_EXTENSION_MAP } from "dr-js/module/common/module/MIME";
import { responderSendBufferCompress, prepareBufferDataAsync } from "dr-js/module/node/server/Responder/Send";
import { configureStatusCollector } from "./configure";
import { createResponderStatusState, createResponderStatusCollect } from "./responder";
import { getHTML } from "./HTML";
const configureFeaturePack = async ({option, logger, routePrefix = "", featureAuth: {authPack: {authFetch}, createResponderCheckAuth, URL_AUTH_CHECK}, statusCollectPath, statusCollectUrl, statusCollectInterval}) => {
  const URL_HTML = `${routePrefix}/status-visualize`;
  const URL_STATUS_STATE = `${routePrefix}/status-state`;
  const URL_STATUS_COLLECT = `${routePrefix}/status-collect`;
  const {factDatabase, timer, collectStatus} = await configureStatusCollector({
    collectPath: statusCollectPath,
    collectUrl: statusCollectUrl,
    collectInterval: statusCollectInterval,
    authFetch
  });
  const HTMLBufferData = await prepareBufferDataAsync(Buffer.from(getHTML({
    URL_AUTH_CHECK,
    URL_STATUS_STATE,
    CONFIG_RENDER_PRESET: {
      StatusRaw: {
        positionScale: .05,
        horizontalDelta: 3600,
        mergeGapMax: 360
      },
      Merge0: {
        positionScale: .01,
        horizontalDelta: 21600,
        mergeGapMax: 1260
      },
      Merge1: {
        positionScale: .001,
        horizontalDelta: 86400,
        mergeGapMax: 3660
      },
      Merge2: {
        positionScale: 5e-4,
        horizontalDelta: 1209600,
        mergeGapMax: 9e4
      }
    }
  })), BASIC_EXTENSION_MAP.html);
  return {
    factDatabase,
    timer,
    collectStatus,
    URL_HTML,
    URL_STATUS_STATE,
    URL_STATUS_COLLECT,
    routeList: [ [ URL_HTML, "GET", store => responderSendBufferCompress(store, HTMLBufferData) ], [ URL_STATUS_STATE, "GET", createResponderCheckAuth({
      responderNext: createResponderStatusState({
        getStatusState: factDatabase.getState
      })
    }) ], [ URL_STATUS_COLLECT, "POST", createResponderCheckAuth({
      responderNext: createResponderStatusCollect({
        addStatus: factDatabase.add
      })
    }) ] ]
  };
};
export { configureFeaturePack };