import { responderSendJSON } from "dr-js/module/node/server/Responder/Send";
import { createGetStatusReport } from "./task/statusReport";
const configureFeaturePack = async ({option, logger, routePrefix = "", featureAuth: {authPack: {authFetch}, createResponderCheckAuth}, statusReportProcessTag}) => {
  const URL_STATUS_REPORT = `${routePrefix}/status-report`;
  const getStatusReport = createGetStatusReport(statusReportProcessTag);
  return {
    URL_STATUS_REPORT,
    routeList: [ [ URL_STATUS_REPORT, "GET", createResponderCheckAuth({
      responderNext: store => responderSendJSON(store, {
        object: getStatusReport()
      })
    }) ] ],
    reportStatus: async url => {
      const {status} = await authFetch(url, {
        method: "POST",
        body: JSON.stringify(getStatusReport())
      });
    }
  };
};
export { configureFeaturePack };